<template>
  <div class="manage-data-page">
    <grid-container>
      <div :class="$style.topFilter">
        <div :class="$style.rightSide">
          <div :class="$style.selectSourceTitle">
            <p>Select Source:</p>
          </div>
          <div :class="$style.filterItemsWrapper">
            <div :class="$style.filterItem">
              <base-select
                name="malek"
                :options="options"
                @onSelect="onItemSelectHandler"
              ></base-select>
            </div>
            <div :class="$style.filterItem">
              <base-select
                name="malek"
                :options="options"
                @onSelect="onItemSelectHandler"
              ></base-select>
            </div>
            <div :class="$style.filterItem">
              <base-button icon="plus" theme="transparent"
                >add new data source</base-button
              >
            </div>
          </div>
        </div>
        <div :class="$style.leftSide">
          <base-button theme="dark">view all data sources</base-button>
        </div>
      </div>
      <base-seperator color="gray" :class="$style.seperator" />
      <div :class="$style.dataPageWrapper">
        <div>
          <div :class="$style.itemsMenuWrapper">
            <transition name="fade">
              <base-loading v-if="showLoadingVerticalMenu" />
              <base-vertical-menu
                v-else
                :data="dataTypesList"
                @onItemSelect="onDataTypeSelect"
              />
            </transition>
          </div>
          <div :class="$style.addButtonWrapper">
            <base-button theme="transparent" icon="plus">Add Key</base-button>
          </div>
        </div>

        <base-card :class="$style.cardWrapper" :showSecondContent="showEdit">
          <!-- show Loading when fetching data -->
          <base-loading v-if="showLoadingDataType" />
          <template #content v-if="!showLoadingDataType">
            <div :class="$style.wrapper">
              <div :class="$style.itemTitle">
                <h3>{{ selectedDataType.name }}</h3>
              </div>
              <base-button
                theme="primary"
                icon="edit"
                @onClick="editButtonHandler"
                >Edit this</base-button
              >
            </div>

            <div :class="$style.itemRow">
              <p :class="$style.itemTitle">Description:</p>
              <p :class="$style.itemContent">
                {{ selectedDataType.description }}
              </p>
            </div>
            <div :class="$style.itemRow">
              <p :class="$style.itemTitle">Type:</p>
              <p :class="$style.itemContent">{{ selectedDataType.type }}</p>
            </div>
            <div :class="$style.itemRow">
              <p :class="$style.itemTitle">Sensivity:</p>
              <p :class="$style.itemContent">
                {{
                  selectedDataType.sensitivity
                    ? "this is personal data, and cannot be distributed in raw form"
                    : "this is general Data"
                }}
              </p>
            </div>
            <div :class="$style.itemRow">
              <base-table
                v-if="
                  selectedDataType.possibleValues &&
                    selectedDataType.possibleValues.length > 0
                "
                :data="selectedDataType.possibleValues"
                title="Possible Values"
                :isEditable="false"
              ></base-table>
            </div>
          </template>

          <!-- second view for edit -->

          <template #contentSec>
            <form action="/some-actiom" method="post">
              <div :class="$style.wrapper">
                <div :class="$style.row">
                  <p :class="$style.itemTitle">Key name:</p>
                  <base-input
                    type="text"
                    name="inputName_keyName"
                    :defaultValue="selectedDataType.name"
                    @onChange="onChangeHandler"
                  />
                </div>
                <base-button
                  theme="primary"
                  icon="flopy-o"
                  @onClick="saveButtonHandler"
                  >Save</base-button
                >
              </div>

              <div :class="$style.itemRow">
                <p :class="$style.itemTitle">Description:</p>
                <base-textarea
                  name="inputName_description"
                  :defaultValue="selectedDataType.description"
                  :cols="5"
                  @onChange="onChangeHandler"
                />
              </div>
              <div :class="$style.itemRow">
                <p :class="$style.itemTitle">Type:</p>
                <base-select
                  name="inputName_type"
                  :options="options"
                  @onSelect="onItemSelectHandler"
                  :defaultValue="selectedDataType.type"
                ></base-select>
              </div>
              <div :class="$style.itemRow">
                <p :class="$style.itemTitle">Sensivity:</p>
                <div :class="$style.formItem">
                  <base-checkbox
                    name="inputName_sensivity"
                    @onChange="onChangeHandler"
                    :defaultValue="selectedDataType.sensivity"
                  >
                    <div :class="$style.checkBoxText">
                      is this personal Data?
                    </div>
                  </base-checkbox>
                </div>
              </div>
              <div :class="$style.itemRow">
                <base-table
                  v-if="
                    selectedDataType.possibleValues &&
                      selectedDataType.possibleValues.length > 0
                  "
                  :data="selectedDataType.possibleValues"
                  title="Possible Values"
                  :isEditable="true"
                ></base-table>
                <base-button
                  theme="transparent"
                  icon="plus"
                  :class="$style.addToTable"
                  @onClick="addNewPossibleValueFormAction"
                  :disabled="showAddNewPossibleValueForm"
                  >Add Possible Values</base-button
                >
              </div>
            </form>

            <div
              :class="$style.addPossibleValuesWrapper"
              v-if="showAddNewPossibleValueForm"
            >
              <form action="/some-action" method="post">
                <p>Add possible values</p>
                <div :class="$style.formField">
                  <p>Value</p>
                  <base-input
                    name="inputName_value"
                    @onChange="onChangeHandler"
                  />
                </div>
                <div :class="$style.formField">
                  <p>Description</p>
                  <base-input
                    name="inputName_description"
                    @onChange="onChangeHandler"
                  />
                </div>
                <div :class="$style.formField">
                  <base-button
                    theme="transparent"
                    icon="plus"
                    :class="$style.addToTable"
                    @onClick="addNewPossibleValue"
                    >Add new possible Value</base-button
                  >
                </div>
              </form>
            </div>
          </template>
        </base-card>
      </div>
    </grid-container>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
//components
// @ts-ignore
import GridContainer from "@/components/grid/GridContainer";
import BaseSelect from "@/components/base/BaseSelect";
import Checkbox from "@/components/base/checkbox";
import Table from "@/components/base/table";
import Tab from "@/components/base/BaseTab/BaseTab";
import Textarea from "@/components/base/textarea";
import BaseButton from "@/components/base/BaseButton";
import BaseSeperator from "@/components/base/BaseSeperator";
import baseVerticalMenu from "@/components/base/BaseVerticalMenu";
import BaseCard from "@/components/base/BaseCard";
import BaseTable from "@/components/base/BaseTable/BaseTable";
import BaseInput from "@/components/base/BaseInput";
import BaseTextarea from "@/components/base/BaseTextarea";
import BaseCheckbox from "@/components/base/BaseCheckbox";
import BaseLoading from "@/components/base/BaseLoading";

// VueX utils
import ActionTypes from "@/store/action_types";
import { mapState, mapActions, mapGetters, mapMutations } from "vuex";

// utils
import validator from "@/services/validation/validator";

export default Vue.extend({
  name: "ManageDataPage",
  components: {
    BaseSelect,
    GridContainer,
    BaseButton,
    BaseSeperator,
    baseVerticalMenu,
    BaseCard,
    BaseTable,
    BaseInput,
    BaseTextarea,
    BaseCheckbox,
    BaseLoading
  },
  data: function() {
    return {
      showEdit: false,
      showLoading: true,
      options: [
        {
          text: "android",
          value: "Malek One"
        },
        {
          text: "ios",
          value: "Malek Second"
        },
        {
          text: "other",
          value: "Malek Third"
        }
      ],
      showAddNewPossibleValueForm: false,
      tabConfig: {
        width: 1000
      },
      inputsValue: {
        inputName_value: "",
        inputName_description: ""
      }
    };
  },
  computed: {
    ...mapState([
      "dataTypesList",
      "selectedDataType",
      "showLoadingVerticalMenu",
      "showLoadingDataType"
    ])
  },
  methods: {
    onDataTypeSelect: function(itemId: string) {
      this.showEdit = false;
      this.getDataTypeInformationFromApi({ itemId });
    },
    onItemSelectHandler: function(item: string) {
      // select box handler
      // console.log(item);
    },
    editButtonHandler: function() {
      // show Edit form
      this.showEdit = !this.showEdit;
    },
    saveButtonHandler: function() {
      // show raw form again
      // all input files  value will be stored in this Object.
      // console.log(this.inputsValue);

      this.showEdit = !this.showEdit;
    },
    addNewPossibleValue: function() {
      if (
        validator(this.inputsValue.inputName_value, {
          name: "minLength",
          value: 2
        })
      ) {
        this.$store.commit(ActionTypes.ADD_NEW_POSSIBLE_VALUE, {
          value: this.inputsValue.inputName_value,
          description: this.inputsValue.inputName_description
        });
      } else {
        alert("error, the input shouldn't be less than 2 character Length");
      }
    },
    addNewPossibleValueFormAction: function() {
      this.showAddNewPossibleValueForm = !this.showAddNewPossibleValueForm;
    },
    onChangeHandler: function(
      event: EventListenerOrEventListenerObject,
      value: string | number,
      name: string
    ) {
      // @ts-ignore
      this.inputsValue[name] = value;
    },
    ...mapActions(["getDataTypeListFromApi", "getDataTypeInformationFromApi"])
  },
  mounted() {
    this.getDataTypeListFromApi();
    this.getDataTypeInformationFromApi({ itemId: 0 });
  }
});
</script>

<style module lang="scss">
.topFilter {
  composes: display--flex;
  composes: justify-content--space-between;
}
.checkBoxText {
  margin-top: 0.2rem;
}
.rightSide {
  composes: display--flex;
}
.leftSide {
  composes: display--flex;
}
.filterItemsWrapper {
  composes: display--flex;
}
.filterItem {
  margin-left: 1rem;
}
.seperator {
  margin: 2rem 0;
}
.addButtonWrapper {
  margin-top: 1rem;
  margin-bottom: 1rem;
}
.dataPageWrapper {
  composes: display--flex;
}
.wrapper {
  composes: display--flex;
  composes: justify-content--space-between;
}
.cardWrapper {
  margin-left: 2rem;
}

.addToTable {
  margin-top: 1.5rem;
}
.itemRow {
  margin-bottom: 2rem;
  margin-top: 2rem;
}
.itemTitle {
  font-size: 1.2rem;
}

.addPossibleValuesWrapper {
  margin-top: 2rem;
  margin-bottom: 2rem;
}

.formField {
  margin-top: 1rem;
  margin-bottom: 1rem;
}

// resposnsive
@media screen and (max-width: $device-size--desktop-laptop) {
  .cardWrapper {
    margin: 0 0;
  }
  .filterItem {
    margin-left: 0;
    margin-right: 1rem;
    margin-bottom: 1rem;
  }
}
@media screen and (max-width: $device-size--tablet) {
  .topFilter,
  .rightSide,
  .leftSide,
  .wrapper,
  .dataPageWrapper {
    flex-direction: column;
  }
  .cardWrapper {
    margin: 0 0;
  }
  .filterItem {
    margin-left: 0;
    margin-right: 1rem;
    margin-bottom: 1rem;
  }
}

@media screen and (max-width: $device-size--mobile-large) {
  .topFilter,
  .rightSide,
  .leftSide,
  .wrapper,
  .dataPageWrapper,
  .filterItemsWrapper {
    flex-direction: column;
  }
  .cardWrapper {
    margin: 0 0;
  }
  .filterItem {
    margin-right: 0;
  }
}
</style>
